
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>hdoj 5391 Zball in Tina Town / 憋错料</title>

    <meta name="description" content="hdoj 5391 Zball in Tina Town 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5391 相关数论结论: 威尔逊定理——当且仅当p为素数时:( p -1 )! ≡ p-1 ( mod p ) 这道题一开始看到的时候以为是暴力的题目,快速阶乘取模,后来其他题做不出来回头看这道题, 发现可以找规律,当p是合数的时候,P的因子全都可以在P前面的数字的因子里找到, 当p是素数的时候,(p-1)!%p = p-1,就尝试写了一下,2A: 因为4是个例外,怕还有其他例外情况,在100以内小规模">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">hdoj 5391 Zball in Tina Town</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>题目链接：<a href="http://acm.hdu.edu.cn/showproblem.php?pid=5391" rel="external nofollow noreferrer">http://acm.hdu.edu.cn/showproblem.php?pid=5391</a></p>
<p>相关数论结论：</p>
<p>威尔逊定理&mdash;&mdash;当且仅当p为素数时：( p -1 )! &equiv; p-1 ( mod p )</p>
<p>这道题一开始看到的时候以为是暴力的题目，快速阶乘取模，后来其他题做不出来回头看这道题，</p>
<p>发现可以找规律，当p是合数的时候，P的因子全都可以在P前面的数字的因子里找到，</p>
<p>当p是素数的时候，(p-1)!%p = p-1，就尝试写了一下，2A；</p>
<p>因为4是个例外，怕还有其他例外情况，在100以内小规模跑了一下暴力。</p>
<pre>#include&lt;stdio.h&gt;
#include&lt;cmath&gt;
using namespace std;
int judge(int n){
    int m = sqrt(n+1);
    int i;
    for(i = 2; i &lt;= m; ++i){
        if( n % i == 0){
            return 0;
        }
    }
    if( i == m + 1)
        return n-1;
}
int main(){
    int T;
    int n;
    int tmp;
    scanf("%d",&amp;T);
    while(T--){
        scanf("%d",&amp;n);

        if( n &lt; 100 ){
            tmp = 1;
            for( int i = 1; i &lt; n; ++i){
                tmp = tmp * i % n;
            }
            printf("%d\n",tmp);
        }
        else
            printf("%d\n",judge(n));
    }
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 01:02:20 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>hdoj 5391 Zball in Tina Town的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPJZKD3.html" rel="bookmark">（hdu）5391  Zball in Tina Town</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接:http://acm.split.hdu.edu.cn/showproblem.php?pid=5391 Problem Description Tina Town is a friendly place. People there care about each other. Tina has a ball called zball. Zball is magic. It grows larger every day. On the first day, it becomes 1 t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MX1rk80.html" rel="bookmark">hdu 5391 Zball in Tina Town 威尔逊定理 数学</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Zball in Tina Town Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Problem Description Tina Town is a friendly place. People there care about each other. Tina has a ball called zball. Zball is magic. It grows lar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/387dlR0.html" rel="bookmark">HDU 5391 Zball in Tina Town【威尔逊定理】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;题目链接&gt; Zball in Tina Town Problem Description Tina Town is a friendly place. People there care about each other.Tina has a ball called zball. Zball is magic. It grows larger every day. On the first day, it becomes 1 time as large as its original siz			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RBknp0.html" rel="bookmark">hdu 5391 Zball in Tina Town</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				点击此处即可传送 hdu 5391 唉,我以为带7的基本上都是素数,所以一直拿1007算,结果....唉,一把辛酸泪啊,算了,不说了,上正事: Problem Description Tina Town is a friendly place. People there care about each other. Tina has a ball called zball. Zball is magic. It grows larger every day. On the first day,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzE8y24.html" rel="bookmark">hdu  5391 Zball in Tina Town&lpar;打表找规律&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Tina Town 是一个善良友好的地方,这里的每一个人都互相关心. Tina有一个球,它的名字叫zball.zball很神奇,它会每天变大.在第一天的时候,它会变大11倍.在第二天的时候,它会变大22倍.在第nn天的时候,它会变大nn倍. zball原来的体积是11.Tina想知道,zball在第n-1n−1天时的体积对nn取模是多大呢? Tina是一个蠢蠢的女孩子,当然不会算啦,所以她请你帮她算出这个答案呢. 输入描述 第一行一个正整数TT,表示数据组数 接下来TT行,每行一个正整			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MggBapM.html" rel="bookmark">hdu 5391 Zball in Tina Town &lpar;素数的判断）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Problem Description Tina Town is a friendly place. People there care about each other.Tina has a ball called zball. Zball is magic. It grows larger every day. On the first day, it becomes 1 time as large as its original size. On the second day,it wil			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXYZqw0.html" rel="bookmark">HDU 5391 Zball in Tina Town （打表，水）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题意: Tina有一个球,它的名字叫zball.zball很神奇,它会每天变大.在第一天的时候,它会变大1倍.在第二天的时候,它会变大2倍.在第n天的时候,它会变大n倍.zball原来的体积是1.Tina想知道,zball在第n−1天时的体积对n取模是多大呢? 思路:如果n是一个合数,那它肯定是有因子的,即有两个比它小的数字a和b,使得a*b=n,那么答案必为0.如果是质数,打表可知是n-1.数字小的直接算,防止意外.数字都不会超过int. #include &lt;cstdio&gt; #include			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r5PBv0.html" rel="bookmark">Zball in Tina Town&lpar;判素数&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Zball in Tina Town Accepts: 397 Submissions: 2463 Time Limit: 3000/1500 MS (Java/Others) Memory Limit: 262144/262144 K (Java/Others) Problem Description Tina Town is a friendly place. People there care about each other. Tina has a ball called zball.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZDkBdM.html" rel="bookmark">BC - Zball in Tina Town &lpar;质数 &plus; 找规律&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Zball in Tina Town Accepts: 541 Submissions: 2463 Time Limit: 3000/1500 MS (Java/Others) Memory Limit: 262144/262144 K (Java/Others) 问题描述 Tina Town 是一个善良友好的地方,这里的每一个人都互相关心. Tina有一个球,它的名字叫zball.zball很神奇,它会每天变大.在第一天的时候,它会变大11倍.在第二天的时候,它会变大22倍.在第nn天的时候,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knnWjM.html" rel="bookmark" class="title">Box Plot</a>
					<div>
						&lt;!DOCTYPE html&gt;&lt;html lang=&quot;en&quot;&gt;&lt;head&gt; &lt;meta charset=&quot;UTF-8&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXlGo0.html" rel="bookmark" class="title">输出9&ast;9口诀</a>
					<div>
						/** * 输出9*9口诀 * */ public class Test4 { public static void main(String[] args) { for (int i = 1; i & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8ZZz0.html" rel="bookmark" class="title">5）NFS存储实时复制原理</a>
					<div>
						项目案例: 1.sudo集权分治的权限管理及命令行日志审计 2.全网数据备份解决方案 3.共享存储实时备份(共享存储的单点解决方案) 第一个里程碑: 1)实现从NFS客户端到rsync服务端的rsyn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomGnl3.html" rel="bookmark" class="title">阿里云 mysql 无缘无故挂掉</a>
					<div>
						近期在登录自己博客时,老是报数据库连接失败,然后重启服务器就好了.但是,重启服务器很耗时间,不方便,不能每次都重启吧于是远程连接服务器看了一下原来是数据库服务挂掉了启动时还报错于是查看了下错误日志 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWDLXM.html" rel="bookmark" class="title">Spring&plus;Rmi中的客户端自动重连配置</a>
					<div>
						&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;&lt;!DOCTYPE beans PUBLIC &quot;-//S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35AANK3.html" rel="bookmark" class="title">LeetCode Walls and Gates</a>
					<div>
						原题链接在这里:https://leetcode.com/problems/walls-and-gates/ 题目: You are given a m x n 2D grid initialized ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvx7z4.html" rel="bookmark" class="title">IOS 解析XML--使用NSXML</a>
					<div>
						一.解析文档顺序触发的函数 1.parserDidStartDocument,在文档的时候触发. 2.parser:didStartElement:namespaceURI:qualifiedName ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLZayE3.html" rel="bookmark" class="title">zabbix3&period;0&lowbar;网络发现问题</a>
					<div>
						问题1. Zabbix网络发现system.uanem找不到主机,打开zabbix_server.conf文件的debug DebugLevel=5 # 错误信息如下 # item [system.u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZNkz4.html" rel="bookmark" class="title">EL表达式&lpar;1&rpar;</a>
					<div>
						JSP页面中支持使用EL表达式,EL全名为Expression Language.EL表达式的主要作用有: ① 获取数据: ② 执行运算: ③ 使用EL表达式的11大隐式对象: ④ 调用Java方法. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZqmOL0.html" rel="bookmark" class="title">jenkins关闭和重启</a>
					<div>
						我们用jar -jar jenkins.war来启动jenkins服务器,那么我们如何关闭或者重启jenkins服务器呢?经过搜索找到了相应的方法. 关闭jenkins服务 只需要在访问jenkins ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGd2E60.html" rel="bookmark" class="title">解决Eclipse中文乱码的问题</a>
					<div>
						注意:显示中文所有的编码方式主要是GBK和UTF-8,UTF-8是国际通用的中文编码标准,推荐使用. 一. 设置工作空间的编码 编辑器的编码会影响到所有的项目中的字符的显示,可以说是作用最为广泛的设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38opWR0.html" rel="bookmark" class="title">JSONP原理及简单实现</a>
					<div>
						文章是转过来的,来自:http://www.travisup.com/post/index/28 在web2.0时代,熟练的使用ajax是每个前端攻城师必备的技能.然而由于受到浏览器的限制,ajax不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezzXZ3.html" rel="bookmark" class="title">Zabbix3&period;0&period;x  zatree安装教程</a>
					<div>
						[目录] zatree3.0.x 快速部署方法   zatree3.0.x 实现原理  zabbix 菜单上显示zatree  zatree界面修改    [zatree3.0.x 快速部署方法]gi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47eLWk0.html" rel="bookmark" class="title">cocos2D-x 3&period;5 引擎解析之--节点（Node）</a>
					<div>
						#ifndef __CCNODE_H__ #define __CCNODE_H__ #include &quot;base/ccMacros.h&quot; #include &quot;base/C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mmm6XpM.html" rel="bookmark" class="title">毕业告别，请别回头！</a>
					<div>
						整体而已,我爱我的母校,武汉理工. 尽管它太年轻,尽管存在着这样的那样的,体制内外的诸多问题,也纵使你经历了什么不公还是遗憾.我想高考,就是一场阴差阳错.可能错过爱情,可能偶遇新人生,有的人自豪,有的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47X66YM.html" rel="bookmark" class="title">&lbrack;错误记录&rsqb;python requests库 Response 判断坑</a>
					<div>
						在requests访问之后, 我直接判断resp的值, 如下: if resp: do something 发现当Response 为500的时候没有进入if分支, 检查源码,发现Response重写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wN8gN0.html" rel="bookmark" class="title">HTML5 CSS3 专题 &colon; 拖放 （Drag and Drop）</a>
					<div>
						本来准备写一个支持多图片拖拽上传的例子,但是为了更好的理解,先介绍一下HTML5的拖放. 拖放(Drag 和 drop)是 HTML5 标准的组成部分. 浏览器支持 Internet Explorer ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K7l2j0.html" rel="bookmark" class="title">愚公移山</a>
					<div>
						太行.王屋二山,方七百里,高万仞.本在冀州之南,河阳之北. 北山愚公者,年且九十,面山而居.惩山北之塞,出入之迂也.聚室而谋曰:“吾与汝毕力平险,指通豫南,达于汉阴,可乎?”杂然相许.其妻献疑曰:“以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWlRbb0.html" rel="bookmark" class="title">awk知识点全回顾</a>
					<div>
						本文目录:1.awk简介和基本语法格式2.print和printf格式化输出3.输入行的字段分隔符和行分隔符4.BGEIN和END5.数组6.流程控制语句 6.1 条件判断语句 6.2 while循环 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QPqLl3.html" rel="bookmark" class="title">ftk学习记（输入框篇）</a>
					<div>
						[ 声明:版权全部.欢迎转载.请勿用于商业用途. 联系信箱:feixiaoxing @163.com] 昨天讲了进度条,我们还是看看它的运行效果是怎么样的.截图例如以下, 进度条使用的情况还是比較多的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
